proc filebrowser {w args}\
{
	global FB_SEARCH FB_CALLER
	eval frame $w -class FileBrowser
	rename $w $w.frame
	pack [frame $w.top] -fill x -side top
	pack [frame $w.dir] -fill x -side top
	pack [frame $w.but] -fill x -side bottom
	pack [frame $w.mid] -fill both
	proc $w {method args} "return \[eval filebrowser__method__\$method $w \$args\]"
	return $w
}

proc filebrowser__method__cget {w args}\
{
	$w.f cget $args
}

proc filebrowser__method__configure {w args}\
{
	eval $w.f configure $args
}

proc filebrowser__configure {}\
{
	upvar w w
	upvar args args
	eval $w.f configure $args
}

proc filebrowser__method__addlistbox {w args}\
{
	global FB_CALLER FB_SEARCH
	if {[winfo exists $w.mid.l]}\
	{
		return
	}
	set FB_CALLER $w
	scrollbar $w.mid.vs -command "$w.mid.l yview"
	pack $w.mid.vs -side right -fill y
	eval listbox $w.mid.l -width 30 -height 10 [lrange $args 1 end]
	$w.mid.l configure -yscrollcommand "$w.mid.vs set"
	pack $w.mid.l -fill both
	bind $w.mid.l <Double-1> "$w readdir selected [lindex $args 0]"
	return $w.mid.l
}

proc filebrowser__method__addbutton {w args}\
{
	set cargs {}
	set text ""
	set default 0
	while {[llength $args] >= 2}\
	{
		switch -exact -- [lindex $args 0]\
		{
			-text {
				set text [lindex $args 1]
			}
			default {
				lappend cargs [lindex $args 0] [lindex $args 1]
			}
		}
		set args [lrange $args 2 end]
	}
	if {[winfo exists $w.but.b$text]}\
	{
		return
	}
	eval button $w.but.b$text -text $text $cargs
	pack $w.but.b$text -side left -expand yes
	return $w.but.b$text
}

proc filebrowser__method__addlabel {w args}\
{
	if {[winfo exists $w.top.lb]}\
	{	
		return
	}
	eval label $w.top.lb $args
	pack $w.top.lb -side left
	return $w.top.lb
}

proc filebrowser__method__adddirlabel {w args}\
{
	if {[winfo exists $w.top.dir]}\
	{	
		return
	}
	eval label $w.dir.dir -borderwidth 0 \
		-highlightthickness 0 \
		-takefocus 0 $args
	pack $w.dir.dir -side left -fill x -expand yes
	return $w.dir.dir
}

proc filebrowser__method__addentry {w args}\
{
	global FB_CALLER FB_SEARCH
	if {[winfo exists $w.top.e]}\
	{	
		return
	}
	set FB_CALLER $w
	eval entry $w.top.e $args
	pack $w.top.e -side left
	bind $w.top.e <Any-Key> \
	{
		if {[ctype alnum %A]}\
		{	
			set FB_SEARCH "[$FB_CALLER.top.e get]%A"
			set el [$FB_CALLER.mid.l get 0 end]
			set ind [lsearch -regexp $el "^$FB_SEARCH.*"]
			$FB_CALLER.mid.l selection clear 0 end
			$FB_CALLER.mid.l selection set $ind
			$FB_CALLER.mid.l see $ind
			update
		}
	}
	return $w.top.e
}

proc filebrowser__method__readdir {w args}\
{
	if {[regexp [lindex $args 0] selected]}\
	{
		set b [$w.mid.l get [$w.mid.l curselection]]
		if {[file isdirectory $b]}\
		{
			set ct [catch {set dir $b}]
			if {$ct > 0}\
			{
				return
			}
			set dir [pwd]/$dir
		}\
		else\
		{
			catch {$w.top.e delete 0 end
				$w.top.e insert 0 $b}
			return
		}
	}\
	else\
	{
		set dir [lindex $args 0]
	}
	catch {$w.mid.l delete 0 end}
	cd $dir
	foreach a [lsort [readdir [pwd]]]\
	{
		if {[file isdirectory $a] || [regexp [lindex $args 1] $a]}\
		{
			catch {$w.mid.l insert end $a}
		}
	}
	catch {$w.mid.l insert 0 ..}
	catch {
		$w.dir.dir configure -text [pwd]
	}
} 
